%global _scl_prefix      /opt/oro
%{?scl:%scl_package elasticsearch}
%{!?scl:%global pkg_name %{name}}

Name: %{?scl_prefix}elasticsearch
Version: 2.4.6
Release: 1%{dist}
Group: Networking/WWW
Packager: Viacheslav Dubrovskyi <vdubrovskyi@oroinc.com>
Summary: Open source, flexible, distributed search and analytics engine
License:       ASL 2.0
Url: http://www.elasticsearch.org
BuildArch: noarch
#Use binary because for build in in koji needs network
Source0: %{pkg_name}-%version.tar.gz
Source1: https://download.elastic.co/elasticsearch/release/org/elasticsearch/plugin/delete-by-query/%version/delete-by-query-%version.zip
Source2: %{pkg_name}.service.in

%{?scl:Requires: %{scl}-runtime}
BuildRequires: oro-elasticsearch24-build

BuildRequires: systemd unzip
Requires: java-headless
# service setup
Requires(post):   systemd
Requires(preun):  systemd
Requires(postun): systemd
# user and group creation
Requires(pre): shadow-utils


%description
Elasticsearch is a search server based on Lucene. It provides a distributed,
multitenant-capable full-text search engine with a RESTful web interface and
schema-free JSON documents. Elasticsearch is developed in Java and is released
as open source under the terms of the Apache License.

It is a flexible and powerful open source, distributed, real-time
search and analytics engine.

Architected from the ground up for use in distributed environments where
reliability and scalability are must haves, Elasticsearch gives you the ability
to move easily beyond simple full-text search.

Through its robust set of APIs and query DSLs, plus clients for the most popular
programming languages, Elasticsearch delivers on the near limitless promises of
search technology.


%prep
%{?scl:scl enable %{scl} - << \EOF}
set -ex
%setup -n %{pkg_name}-%{version}
find . -name *.exe -delete
find . -name *.bat -delete

mkdir -p plugins/delete-by-query
cd plugins/delete-by-query
unzip %SOURCE1

%{?scl:EOF}

%install
%{?scl:scl enable %{scl} - << \EOF}
set -ex
mkdir -p %buildroot%_datadir/%pkg_name
mkdir -p %buildroot%_bindir
mkdir -p %buildroot%_sysconfdir
mkdir -p %buildroot%_localstatedir/log/%pkg_name
mkdir -p %buildroot%_localstatedir/lib/%pkg_name
mkdir -p %buildroot%_unitdir


cp -rf * %buildroot%_datadir/%pkg_name/
mv -f %buildroot%_datadir/%pkg_name/config %buildroot%_sysconfdir/%pkg_name
ln -s ../share/%pkg_name/bin/%pkg_name %buildroot%_bindir/%pkg_name
ln -s %_sysconfdir/%pkg_name %buildroot%_datadir/%pkg_name/config
ln -s %_localstatedir/lib/%pkg_name %buildroot%_datadir/%pkg_name/data
ln -s %_localstatedir/log/%pkg_name %buildroot%_datadir/%pkg_name/logs

cat %{SOURCE2} | sed "s;@LAUNCHER@;%_bindir/%{pkg_name};g" | sed "s;@ENV_FILE@;%_sysconfdir/sysconfig/%pkg_name;g" | sed  "s;@USER@;%{pkg_name};g"  > $RPM_BUILD_ROOT/%{_unitdir}/%{name}.service
mkdir -p %buildroot%_sysconfdir/sysconfig
touch %buildroot%_sysconfdir/sysconfig/%pkg_name

%{?scl:EOF}


%pre
# add the elasticsearch user and group
getent group  %{pkg_name} >/dev/null || /usr/sbin/groupadd -r %{pkg_name}
getent passwd %{pkg_name} >/dev/null || /usr/sbin/useradd -r -g %{pkg_name} -d %{_sharedstatedir}/%{pkg_name} -s /usr/sbin/nologin \
    -c "Elastic Search shared service user" elasticsearch
exit 0


%post
%systemd_post %{name}.service
/bin/systemctl daemon-reload


%preun
%systemd_preun %{name}.service


%postun
%systemd_postun_with_restart %{name}.service


%files
%doc LICENSE* README* NOTICE*
%attr(770,root,%pkg_name) %dir %_sysconfdir/%pkg_name
%attr(640,root,%pkg_name) %config(noreplace) %_sysconfdir/%pkg_name/*
%config(noreplace) %_sysconfdir/sysconfig/%pkg_name
%_unitdir/*
%_bindir/*
%_datadir/%pkg_name
%attr(0755,%pkg_name,%pkg_name) %dir %_localstatedir/log/%pkg_name
%attr(0755,%pkg_name,%pkg_name) %dir %_localstatedir/lib/%pkg_name



%changelog
* Fri Apr 27 2018 Viacheslav Dubrovskyi <vdubrovskyi@oroinc.com> - 2.4.6-1
- New version
- Remove windows files
- Add environment file

* Fri Feb 23 2018 Viacheslav Dubrovskyi <vdubrovskyi@oroinc.com>
- Initial build for Oro
